--Figs by UwV to go with the draw function. (for dark background & light font)
--Size of Figs :7x4


RasChess._SansSerif = {}

--Table With White Figs
RasChess._SansSerif.White = {}

RasChess._SansSerif.White.Pawn = {}
RasChess._SansSerif.White.Pawn[1] =	"    _._   "
RasChess._SansSerif.White.Pawn[2] =	"    (-'')'   "
RasChess._SansSerif.White.Pawn[3] =	"  /\\   "
RasChess._SansSerif.White.Pawn[4] =	"  ()  "

RasChess._SansSerif.White.Castle = {}
RasChess._SansSerif.White.Castle[1] =	" XXX"
RasChess._SansSerif.White.Castle[2] =	"  '  "
RasChess._SansSerif.White.Castle[3] =	"  '  "
RasChess._SansSerif.White.Castle[4] =	" ' "

RasChess._SansSerif.White.Horse = {}
RasChess._SansSerif.White.Horse[1] =	"  __.,,..,"
RasChess._SansSerif.White.Horse[2] =	" (_     )"
RasChess._SansSerif.White.Horse[3] =	"  _/I''"
RasChess._SansSerif.White.Horse[4] =	"/ H \\"

RasChess._SansSerif.White.Bishop = {}
RasChess._SansSerif.White.Bishop[1] =	"  _'_  "
RasChess._SansSerif.White.Bishop[2] =	"  \\'/  "
RasChess._SansSerif.White.Bishop[3] =	"    ()    "
RasChess._SansSerif.White.Bishop[4] =	"  ()  "

RasChess._SansSerif.White.Queen = {}
RasChess._SansSerif.White.Queen[1] =	"   /iiii\\   "
RasChess._SansSerif.White.Queen[2] =	"    ()    "
RasChess._SansSerif.White.Queen[3] =	"  /Q\\  "
RasChess._SansSerif.White.Queen[4] =	"/'\\"

RasChess._SansSerif.White.King = {}
RasChess._SansSerif.White.King[1] =	"  _/'\\_  "
RasChess._SansSerif.White.King[2] =	"  \\'/  "
RasChess._SansSerif.White.King[3] =	"   ('K)  "
RasChess._SansSerif.White.King[4] =	" () "


--Table With Black Figs

RasChess._SansSerif.Black = {}

RasChess._SansSerif.Black.Pawn = {}
RasChess._SansSerif.Black.Pawn[1] =	"   .__.   "
RasChess._SansSerif.Black.Pawn[2] =	"   '(''-)    "
RasChess._SansSerif.Black.Pawn[3] =	"   /  \\  "
RasChess._SansSerif.Black.Pawn[4] =	"  (___)  "

RasChess._SansSerif.Black.Castle = {}
RasChess._SansSerif.Black.Castle[1] =	" XXX"
RasChess._SansSerif.Black.Castle[2] =	"      '   "
RasChess._SansSerif.Black.Castle[3] =	"    '     "
RasChess._SansSerif.Black.Castle[4] =	" ____ "

RasChess._SansSerif.Black.Horse = {}
RasChess._SansSerif.Black.Horse[1] =	" .,,..,__ "
RasChess._SansSerif.Black.Horse[2] =	"///  _)"
RasChess._SansSerif.Black.Horse[3] =	"  I   ''\\_ "
RasChess._SansSerif.Black.Horse[4] =	" /  H   \\"

RasChess._SansSerif.Black.Bishop = {}
RasChess._SansSerif.Black.Bishop[1] =	"  _'_  "
RasChess._SansSerif.Black.Bishop[2] =	"  \\_'_/  "
RasChess._SansSerif.Black.Bishop[3] =	"    (_)    "
RasChess._SansSerif.Black.Bishop[4] =	"  (___)  "

RasChess._SansSerif.Black.Queen = {}
RasChess._SansSerif.Black.Queen[1] =	"   /iiii\\   "
RasChess._SansSerif.Black.Queen[2] =	"    (  )    "
RasChess._SansSerif.Black.Queen[3] =	"  / Q \\  "
RasChess._SansSerif.Black.Queen[4] =	"/__'__\\"

RasChess._SansSerif.Black.King = {}
RasChess._SansSerif.Black.King[1] =	"  _/'\\_  "
RasChess._SansSerif.Black.King[2] =	"  \\''  ''/  "
RasChess._SansSerif.Black.King[3] =	"   (''K'')  "
RasChess._SansSerif.Black.King[4] =	" (____) "


-- DrawBoard Draws the current Board
-- Awaits as argument the currentgame
-- Returns the Board as "string"

-- For MS Sans Serif

-------------------------------------
--	Draw Board (edited by UwVerlosser) 
-------------------------------------
function RasChess._SansSerif.DrawBoard(curgame)


	-- Conversion curgame NumChink to Char
	local ConChinkChar = {
		[1] = "H",
		[2] = "G",
		[3] = "F",
		[4] = "E",
		[5] = "D",
		[6] = "C",
		[7] = "B",
		[8] = "A",
	}

	local nicktop = curgame.sides.Top
	local nickbottom = curgame.sides.Bottom
	local line5 = string.rep(" ",5)
	local ChessBoard = "\r\n\t\t\t\t\t[ "..nicktop.." ]  -  WHITE\r\n\t"..string.rep(" ",5).. "'" 
	for i = 1,8 do
		ChessBoard = ChessBoard..string.rep(" ",10)..ConChinkChar[i]..string.rep(" ",10).. "'"
	end

	ChessBoard = ChessBoard.."\r\n\t"..string.rep(" ",7)..string.rep("_",91)
	for i = 1,8,2 do
		
		--Draw Begining with Black
		ChessBoard = ChessBoard.."\r\n\t"..string.rep(" ",6)..string.char(166)..string.char(166)
		for _ = 1,8 do
			ChessBoard = ChessBoard..string.rep("",11)..string.char(166)
		end
		ChessBoard = ChessBoard..string.char(166) 	
		for i2 = 1,4 do
			if (i2 == 2) then
				ChessBoard = ChessBoard.."\r\n\t"..i..string.rep(" ",4)..string.char(166)..string.char(166) 
			else
				ChessBoard = ChessBoard.."\r\n\t"..string.rep(" ",6)..string.char(166)..string.char(166)
			end
			for i3 = 1,8,2 do
				ChessBoard = ChessBoard.." "..RasChess._SansSerif.GetFigsString(curgame[i..i3].ftype,i2,"B").." "..string.char(166).."     "..RasChess._SansSerif.GetFigsString(curgame[i..(i3+1)].ftype,i2,"W").."     "..string.char(166)
			end
			ChessBoard = ChessBoard..string.char(166)
			if (i2 == 2) then
				ChessBoard = ChessBoard..string.rep(" ",5)..i 	
			end
		end

		--Draw Begining with White
		ChessBoard = ChessBoard.."\r\n\t"..string.rep(" ",6)..string.char(166)..string.char(166)
		for _ = 1,8 do
			ChessBoard = ChessBoard..string.rep("",11)..string.char(166) 
		end
		ChessBoard = ChessBoard..string.char(166) 	
		for i2 = 1,4 do
			if (i2 == 2) then
				ChessBoard = ChessBoard.."\r\n\t"..(i+1)..string.rep(" ",4)..string.char(166)..string.char(166)
			else
				ChessBoard = ChessBoard.."\r\n\t"..string.rep(" ",6)..string.char(166)..string.char(166)
			end
			for i3 = 1,8,2 do
				ChessBoard = ChessBoard.."     "..RasChess._SansSerif.GetFigsString(curgame[(i+1)..i3].ftype,i2,"W").."     "..string.char(166).." "..RasChess._SansSerif.GetFigsString(curgame[(i+1)..(i3+1)].ftype,i2,"B").." "..string.char(166) 
			end
			ChessBoard = ChessBoard..string.char(166)	
			if (i2 == 2) then
				ChessBoard = ChessBoard..string.rep(" ",5)..(i+1) 
			end
		end

	end
	ChessBoard = ChessBoard.."\r\n\t"..string.rep(" ",6)..string.char(166)..string.char(166)
	for _ = 1,8 do
		ChessBoard = ChessBoard..string.rep("",11)..string.char(166)
	end
	ChessBoard = ChessBoard..string.char(166).."\r\n\t"..string.rep(" ",7)..string.rep("",91)

	ChessBoard = ChessBoard.."\r\n\t"..string.rep(" ",5).. "'" 
	for i = 1,8 do
		ChessBoard = ChessBoard..string.rep(" ",10)..ConChinkChar[i]..string.rep(" ",10).. "'"
	end
	ChessBoard = ChessBoard.."\r\n\t\t\t\t\t[ "..nickbottom.." ]  -  BLACK\r\n"	
	return(ChessBoard)
end
-- Get Figures string
function RasChess._SansSerif.GetFigsString(fig,num,cfield)
	if (fig[2] == "W") then
		return RasChess._SansSerif.White[fig[1]][num]
	elseif (fig[2] == "B") then
		return RasChess._SansSerif.Black[fig[1]][num]
	end
	if (cfield == "W") then
		return ("            ")
	elseif (cfield == "B") then
		return ("")
	end
end